Sophie

Sophie

distrib > Fedora > 15 > i386 > by-pkgid > fbe3cb3c4df145e372a48e3c80b63097 > files > 21

bacula2-common-2.4.4-7.fc15.i686.rpm

#!/bin/ksh
#
# Bacula interface to mtx autoloader
#
#  This script is not needed with Bacula version 1.38 or later
#  since the Storage daemon automatically ensures that only one
#  thread accesses the script at a time.     
#
#
#  $Id: locking-mtx-changer 2805 2006-02-22 18:43:55Z kerns $
#
#  If you set in your Device resource
#
#  Changer Command = "path-to-this-script/mtx-changer %c %o %S %a %d
#    you will have the following input to this script:
#
#  mtx-changer "changer-device" "command" "slot" "archive-device" "drive-index"
#                  $1              $2       $3        $4               $5
#
#  for example:
#
#  mtx-changer /dev/sg0 load 1 /dev/nst0 0 (on a Linux system)
#
#  If you need to an offline, refer to the drive as $4
#    e.g.   mt -f $4 offline
#
#  Many changers need an offline after the unload. Also many
#   changers need a sleep 60 after the mtx load.
#
#  N.B. If you change the script, take care to return either 
#   the mtx exit code or a 0. If the script exits with a non-zero
#   exit code, Bacula will assume the request failed.
#

MTX=/lysator/bin/mtx
LOCKDIR=/tmp

if test $# -lt 2 ; then
  echo "usage: mtx-changer ctl-device command slot archive-device drive"
  echo "  Insufficient number of arguments arguments given."
  echo "  Mimimum usage is first two arguments ..."
  exit 1
fi

# Setup arguments
ctl=$1
cmd="$2"
slot=$3
device=$4
# If drive not given, default to 0
if test $# = 5 ; then
  drive=$5
else
  drive=0
fi

wait_for_drive() {
    while ! mt -f $1 status >/dev/null 2>/dev/null; do
#       echo "Device $1 - not ready, retrying..."
        sleep 5
    done
}

LOCKFILE="${LOCKDIR}/mtx-changer:`echo $ctl | tr / _'"

changer_lock() {
    echo "$$" >$LOCKFILE.$$
    
    while ! ln -n $LOCKFILE.$$ $LOCKFILE 2>/dev/null; do
       echo "$0: changer lock busy, retrying in 30 seconds..."
       sleep 30
    done

    rm $LOCKFILE.$$
}

changer_unlock() {
    LOCKPID="`cat $LOCKFILE 2>/dev/null`"
    if [ "$LOCKPID" != $$ ]; then
        echo "$0: Invalid lock file (${LOCKFILE}) - not owned by us!"
        exit 1
    fi
    rm -f $LOCKFILE
}



#
# Check for special cases where only 2 arguments are needed, 
#  all others are a minimum of 3
case $cmd in
   loaded)
     ;;
   unload)
     ;;
   list)
     ;;
   slots)
     ;;
   *)
     if test $# -lt 3; then
        echo "usage: mtx-changer ctl-device command slot archive-device drive"
        echo "  Insufficient number of arguments arguments given."
        echo "  Mimimum usage is first three arguments ..."
        exit 1
     fi
     ;;
esac

changer_lock $ctl

case $cmd in 
   unload)
#     echo "Doing mtx -f $ctl unload $slot $drive"
#
# enable the following line if you need to eject the cartridge
      mt -f $device offline
      if test x$slot = x; then
         ${MTX} -f $ctl unload
         rtn=$?
      else
         ${MTX} -f $ctl unload $slot $drive
         rtn=$?
      fi
      ;;

   load)
#     echo "Doing mtx -f $ctl load $slot $drive"
      ${MTX} -f $ctl load $slot $drive
      rtn=$?

      wait_for_drive $device
      changer_unlock $ctl
      exit $rtn
      ;;

   list) 
#     echo "Requested list"
      ${MTX} -f $ctl status | tr ':=' '  ' | nawk '($1 == "Storage" && $2 == "Element" && $4 == "Full") { printf "%s:%s\n", $3, $6 }'
      rtn=$?
      ;;

   loaded)
      ${MTX} -f $ctl status >/tmp/mtx.$$
      rtn=$?
      cat /tmp/mtx.$$ | grep "^Data Transfer Element $drive:Full" | awk "{print \$7}"
      cat /tmp/mtx.$$ | grep "^Data Transfer Element $drive:Empty" | awk "{print 0}"
      rm -f /tmp/mtx.$$
      changer_unlock $ctl
      exit $rtn
      ;;

   slots)
#     echo "Request slots"
      ${MTX} -f $ctl status | grep " *Storage Changer" | awk "{print \$5}"
      rtn=$?
      ;;
esac

changer_unlock $ctl
exit $rtn